CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  rxpin = 31 ' Receive on I/O pin 1 <- black from master black txpin p1 
  txpin = 30 ' Transmit on I/O pin 0 -> red to master red rxpin p0
  ServoCh1 = 16  'Pan                            
  ServoCh2 = 20  'Tilt
  ServoCh3 = 0   'Steering servo
  MotorChA = 6
  MotorChB = 7
   
VAR
  
  LONG Drivestack[16]
  LONG InitStack[12]
  LONG txVal_1, txVal_2, txVal_3, txVal_4 ' transmit
  LONG rxVal_1, rxVal_2, rxVal_3, rxVal_4 ' receive from master and PST
  LONG rxVal
  LONG rxHeight 
  LONG rxWidth 
  LONG rxTurretL 
  LONG rxTurretR
  LONG rxSteerL
  LONG rxSteerR
  LONG Tilt
  LONG Pan
  LONG rxDriveF
  LONG rxDriveR
  
OBJ

  serial : "FullDuplexSerial"   ' "Extended_FDSerial" '' 
  f : "Float32Full" 
  SERVO : "Servo32v7.spin"
  PWM     : "PWM_32_v2.spin"
 
PUB Main | DutyCycle, temp ' new stuff DutyCycle
  
                   
  SERVO.Start
  SERVO.Ramp
  PWM.Start
  InitA
  serial.start(rxpin,txpin,%0000, 115200)        '- rxpin,txpin,mode,Baud  
  Cognew(Drive,@DriveStack)
  repeat                           
     
     rxHeight := SerCog
     rxWidth := SerCog
     rxTurretR := SerCog 
     rxTurretL := SerCog
     rxSteerR := SerCog      
     rxSteerL := SerCog
     rxDriveR := SerCog
     rxDriveF := SerCog                              
                                   'Transmit values                             
     WheelAngle
     Drive                               'Wheel Angle for steering
'      HeadAngle
     Transmitter
PUB InitA

    PWM.Servo(6,1400)
    waitcnt(20)           '' Define Pin0 with a standard center position
    PWM.Servo(7,1400)
    
PUB SerCog 

    rxVal_1 := serial.rx                        'Get next value from roborealm
    rxVal_2 := serial.rx 
    rxVal_3 := serial.rx 
    rxVal_4 := serial.rx 
    
    rxVal := rxVal_1 | (rxVal_2<<8) | (rxVal_3<<16) | (rxVal_4<<24)
    
    RETURN rxVal
{
\\[IMAGE_HEIGHT]\\[IMAGE_WIDTH]\\[NV_TURRET_LEFT]\\[NV_RIGHT]\\[NV_LEFT]\\[NV_BACKWARDS]\\[NV_FORWARD]
}     
PUB Transmitter

    serial.dec(rxHeight) 
    serial.tx(13) 
    serial.dec(rxWidth) 
    serial.tx(13) 
    serial.dec(rxTurretR) 
    serial.tx(13)
    serial.dec(rxTurretL) 
    serial.tx(13) 
    serial.dec(rxSteerR) 
    serial.tx(13)
    serial.dec(rxSteerL) 
    serial.tx(13)
    serial.dec(rxDriveR) 
    serial.tx(13)
    serial.dec(rxDriveF) 
    serial.tx(13)
    
PUB WheelAngle

    IF rxSteerL == 1                              'If value is 1 turn right
      SERVO.SetRamp(ServoCh3,1000,70)
      SERVO.SetRamp(ServoCh1,2000,300)
    IF rxSteerR == 1
      SERVO.SetRamp(ServoCh3,1900,70)
      SERVO.SetRamp(ServoCh1,1000,300)            'If value is 1 turn left
    IF rxSteerR == 0 and rxSteerL == 0            'If value is 0 no turn 
      SERVO.SetRamp(ServoCh3,1425,70)
      SERVO.SetRamp(ServoCh1,1400,300)
    
 '   SERVO.SetRamp(ServoCh2,Tilt,100)           'Set servo movement with variables
           
PUB Drive

    IF rxDriveF == 1
      PWM.Servo(MotorChA,1375)           'Initialize ESC A          
      PWM.Servo(MotorChB,1430)           'Initialize ESC B
      PWM.PhaseSync(MotorChA,MotorChB,5555)
      repeat 1500000
    IF rxDriveF == 0   
      PWM.Servo(MotorChA,1400)           'Initialize ESC A          
      PWM.Servo(MotorChB,1400)           'Initialize ESC B
      repeat 1500000
    IF rxDriveR == 1   
      PWM.Servo(MotorChA,1425)           'Initialize ESC A          
      PWM.Servo(MotorChB,1370)           'Initialize ESC B
      repeat 1500000
    IF rxDriveR == 0   
      PWM.Servo(MotorChA,1400)           'Initialize ESC A          
      PWM.Servo(MotorChB,1400)           'Initialize ESC B
      repeat 1500000
        
          
                                                 'Pulsewidth #1400 is 0% duty
                                                 '    "      #1500 is 100% forward
                                                 '    "      #1300 is 100% reverse
            